# New Contributor Guide **Developers**

This document contains some useful resources for anyone wishing to contribute to the Lapce project by contributing code.

## Quick Start

1. Get an overview of the architecture from [`docs/why-lapce.md`](why-lapce.md) and [Architecture](https://docs.lapce.dev/development/architecture).

2. Explore the rope data structure, a key part of Lapce's architecture. The crate used is [xi_rope](https://crates.io/crates/xi-rope).

3. Review both open and closed [issues](https://github.com/lapce/lapce/issues), there may be others working on a similar feature.

4. [Get cracking](https://dictionary.cambridge.org/dictionary/english/get-cracking)!

5. Be aware that unless you explicitly state otherwise, contributions you make to this project will be under the Apache License Version 2.

## Resources

The [Wikipedia article on ropes](https://en.wikipedia.org/wiki/Rope_(data_structure)) provides an overview of the data structure.

For some context, also see [Ropes: an Alternative to Strings](https://www.cs.tufts.edu/comp/150FP/archive/hans-boehm/ropes.pdf) by Boehm, Atkinson, and Plass.


